open import NomPa.Record
import NomPa.Derived
open import Data.List
open import Data.Sum hiding (map)
open import Function

module NomPa.Examples.LC.Combined (nomPa : NomPa) where

open NomPa nomPa
open NomPa.Derived nomPa

data Tm s α : Set where
  V    : Name α → Tm s α
  ƛᴺ   : ∀ b → Tm s (b ◅ α) → Tm s α
  ƛᴰ   : Tm s (α ↑1) → Tm s α
  ƛᴸ   : Tm (sucᴮ s) (s ◅ α) → Tm s α
  _·_  : (t u : Tm s α) → Tm s α
  Letᴺ : ∀ b → (t : Tm s α) (u : Tm s (b ◅ α)) → Tm s α

-- rm and map
{-
rm : ∀ {α β} b → (Name α → Name β) → List (Name (b ◅ α)) → List (Name β)
rm b f []         = []
rm b f (x ∷ xs) with exportᴺ x
...   {- bound -}  |  inj₁ _  = rm b f xs
...   {- free  -}  |  inj₂ x′  = f x′  ∷ rm b f xs

rm₀ᴰ : ∀ {α} → List (Name (α ↑1)) → List (Name α)
rm₀ᴰ = rm (0 ᴮ) predᴺ
-}

rm₀ᴰ : ∀ {α} → List (Name (α ↑1)) → List (Name α)
rm₀ᴰ = map predᴺ ∘ rm (0 ᴮ)

fv : ∀ {α s} → Tm s α → List (Name α)
fv (V x)        = [ x ]
fv (fct · arg)  = fv fct ++ fv arg
fv (ƛᴺ b t)     = rm b (fv t)
fv (ƛᴰ t)       = rm₀ᴰ (fv t)
fv (ƛᴸ t)       = rm _ (fv t)
fv (Letᴺ b t u) = fv t ++ rm _ (fv u)
