module Function.Im where

import Relation.Binary.PropositionalEquality as ≡
open ≡ using (_≡_)

data Im {A B : Set} (f : A → B) : B → Set where
  im : ∀ x → Im f (f x)

preIm : ∀ {A B} {f : A → B} {y} → Im f y → A
preIm (im x) = x

leftInverse : ∀ {A B : Set} (f : A → B) (f⁻¹ : (x : B) → Im f x) x → f (preIm (f⁻¹ x)) ≡ x
leftInverse f f⁻¹ x with f⁻¹ x
leftInverse f _ .(f y) | im y = ≡.refl

module TestIm where
  open import Data.Nat

  data N2 : Set where
    zero : N2
    suc : N2 -> N2

  ⇒ : ℕ → N2
  ⇒ zero = zero
  ⇒ (suc n) = suc (⇒ n)

  ⇐ : (x : N2) → Im (⇒) x
  ⇐ zero = im zero
  ⇐ (suc n) with ⇐ n
  ⇐ (suc ._)   | im m = im (suc m)
